﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=11.2
@EndOfDesignText@
'B4A=True
'Group=Default Group
'ModulesStructureVersion=1
'Type=Class
'Version=10.6
'@EndOfDesignText@

Sub Class_Globals
	Type TMapShapePolygon(fLatLng As List, fColor As Int, fFilled As Boolean, fStrokeWidth As Double, fData As Object)
	Private fcvMap As cvMap
	Private fShape As TMapShapePolygon
	Private mLayer As Int 'added RBS 02/05/2022
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(aCVMap As cvMap, aShape As TMapShapePolygon)
	fcvMap = aCVMap
	fShape = aShape
	mLayer = MapUtilities.iPolygonLayer 'added RBS 02/05/2022
End Sub

'draw the shape
Public Sub Draw
	
	'>>> RBS altered 05/03/22
	'------------------------
	Dim p As B4XPath
	Dim ptStart As TMapPoint = fcvMap.LatLngToPoint(fShape.fLatLng.Get(0)) 'first polygon point
	
	p.Initialize(ptStart.fx,ptStart.fy)
	For i = 1 To fShape.fLatLng.Size-1
		Dim ptNext As TMapPoint=fcvMap.LatLngToPoint(fShape.fLatLng.Get(i))
		p.LineTo(ptNext.fx, ptNext.fy)
	Next
	'Dim pt As TMapPoint = fcvMap.LatLngToPoint(fShape.fLatLng.Get(0)) '<<<<<<< duplicate, was already set above
	p.LineTo(ptStart.fx, ptStart.fy)
	fcvMap.ShapeCanvas.DrawPath(p,fShape.fColor,fShape.fFilled, fShape.fStrokeWidth)

End Sub

'return true if point is in shape
Public Sub PointInShape(aPoint As TMapPoint) As Boolean
	
	'https://wrf.ecse.rpi.edu/Research/Short_Notes/pnpoly.html
	
	'General.StartSW(1)
	
	'to do a quick and simple check first
	Dim r As B4XRect = BoundingBox(fShape)
	If (aPoint.fX < r.left) Or (aPoint.fX > r.Right) Or (aPoint.fY < r.Top) Or (aPoint.fY > r.Bottom) Then
		Return False
	End If

	Dim bInside As Boolean
	Dim i As Int
	Dim j As Int = fShape.fLatLng.size - 1
	
	For i = 0 To fShape.fLatLng.Size - 1
		Dim pti As TMapPoint = fcvMap.LatLngToPoint(fShape.fLatLng.Get(i))
		Dim ptj As TMapPoint = fcvMap.LatLngToPoint(fShape.fLatLng.Get(j))
		If ((pti.fy > aPoint.fY) <> (ptj.fy > aPoint.fY)) And _
			(aPoint.fX < (ptj.fX - pti.fX) * (aPoint.fY - pti.fY) / (ptj.fy - pti.fY) + pti.fX) Then
			bInside = Not(bInside)
		End If
		j = i
	Next
	
	'Log(General.FormatMilliSecs(General.StopSW(1)))
	
	Return bInside
	
End Sub

'get shape
Public Sub get_Shape As TMapShapePolygon
	Return fShape
End Sub

'set shape
Public Sub set_Shape(aShape As TMapShapePolygon)
	fShape=aShape
End Sub

'return shape type
Public Sub getShape_Type As String
	Return "polygon"
End Sub

'return shape data
Public Sub getShape_Data As Object
	Return fShape.fData
End Sub

Public Sub BoundingBox(aShape As TMapShapePolygon) As B4XRect
		
	'>>> altered RBS 05/03/2022
	Dim r As B4XRect
	
	Dim dMinLat As Double
	Dim dMaxLat As Double
	Dim dMinLng As Double
	Dim dMaxLng As Double
	
	Dim tLLNW As TMapLatLng
	Dim tLLSE As TMapLatLng
	
	Dim pNW As TMapPoint
	Dim pSE As TMapPoint
	
	dMinLat = 100
	dMaxLat = -100
	dMinLng = 200
	dMaxLng = -200
	
	For Each ll As TMapLatLng In aShape.fLatLng
		If ll.flat > dMaxLat Then
			dMaxLat = ll.flat
		End If
		If ll.flat < dMinLat Then
			dMinLat = ll.flat
		End If
		If ll.flng > dMaxLng Then
			dMaxLng = ll.flng
		End If
		If ll.flng < dMinLng Then
			dMinLng = ll.flng
		End If
	Next
	
	tLLNW.fLat = dMaxLat
	tLLNW.fLng = dMinLng
	tLLSE.fLat = dMinLat
	tLLSE.fLng = dMaxLng
	
	pNW = fcvMap.LatLngToPoint(tLLNW)
	pSE = fcvMap.LatLngToPoint(tLLSE)
	
	r.Initialize(pNW.fx, pNW.fy, pSE.fx, pSE.fy)
	
	Return r
	
End Sub

'added RBS 02/05/2022
Public Sub getlayer As Int
	Return mLayer
End Sub

Public Sub setlayer(iLayer As Int)
	mLayer = iLayer
End Sub