﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=11.2
@EndOfDesignText@
'B4A=True
'Group=Default Group
'ModulesStructureVersion=1
'Type=Class
'Version=10.6
'@EndOfDesignText@

Sub Class_Globals
	Private fXUI As XUI
	Private fDB As SQL
	Private fOffLine As Boolean=False
	Private B4XProgressBar1 As B4XProgressBar
	Private mParent As Activity 'this is needed for the progressbar
	Public bConnected As Boolean
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(oParent As Activity)
	mParent = oParent
	dbInit
End Sub

Public Sub setOffline(avalue As Boolean)
	fOffLine=avalue
End Sub

Public Sub getOffline As Boolean
	Return fOffLine
End Sub

Public Sub Connected() As Boolean
	
	Try
		Dim b As Boolean = fDB.IsInitialized
		Return b
	Catch
		Return False
	End Try
	
End Sub

'needed for when copying the DB
Public Sub CloseDB() As Boolean 'ignore
	
	If bConnected  Then
		fDB.Close
		bConnected = False
		Return Connected
	Else
		Return True
	End If
	
End Sub

'open db, create it if necessary
Private Sub dbInit
	
	Dim strSQL As String
	
	strSQL = "CREATE TABLE tiles(" & _
			 "zoom_level INTEGER NOT NULL, " & _
			 "tile_column INTEGER Not Null, " & _
			 "tile_row INTEGER Not Null, " & _
			 "tile_data BLOB Not Null, primary key (zoom_level, tile_column, tile_row))"

	fXUI.SetDataFolder("")
	If Not(File.Exists(fXUI.DefaultFolder,"tiles.db3")) Then
		#if B4A or B4i
		fDB.Initialize(fXUI.DefaultFolder,"tiles.db3",True)
		#else if B4J
			fDB.InitializeSQLite(fXUI.DefaultFolder,"tiles.db3",True)
		#end if
		fDB.ExecNonQuery(strSQL)
		bConnected = True
	Else
		
		Dim strSQL As String
		Dim RS1 As ResultSet

		#if B4A or B4i
		fDB.Initialize(fXUI.DefaultFolder, "tiles.db3", False)
		
		If MapUtilities.mapDBRowsColumns.IsInitialized = False Then
			strSQL = "select zoom_level, min(tile_column), max(tile_column), min(tile_row), max(tile_row) from tiles group by zoom_level"
			RS1 = fDB.ExecQuery(strSQL)
			MapUtilities.SetupMapDBRowsColumns(RS1)
			RS1.Close
		End If
		
		#else if B4J
			fDB.InitializeSQLite(fXUI.DefaultFolder,"tiles.db3",False)
		#End If
		
		bConnected = True
	End If
End Sub

'Get Tile from DB ,if not found, then get from Internet and store it in DN
'-------------------------------------------------------------------------
Public Sub getTile(iZ As Int,iX As Long,iY As Long) As ResumableSub
	
	'Log("getTile, iZ: " & iZ & " iX: " & iX & ", iY: " & iY)

	Dim bmp As B4XBitmap = getTileFromDB(iZ,iX,iY)

	If Not(bmp.IsInitialized) Then
		If Not(fOffLine) Then
			wait for (getTileFromInternet(iZ,iX,iY)) complete (bmp As B4XBitmap)
			If bmp.IsInitialized Then
				setTileToDB(iZ,iX,iY,bmp)
			End If
		End If
	End If
	
	If Not(bmp.IsInitialized) Then
		Dim bc As BitmapCreator
		bc.Initialize(MapUtilities.cTileSize,MapUtilities.cTileSize)
		Dim s As Int=(MapUtilities.cTileSize/16)
		For i=1 To s-1
			bc.DrawLine(i*s,0,0,i*s,fXUI.Color_Blue,2dip)
		Next
		bmp=bc.Bitmap
	End If
	
	Return bmp
	
End Sub

'Get Tile from internet openstreemap website, note maximum zoom level is 19
Public Sub getTileFromInternet(iZ As Int,iX As Int, iY As Int) As ResumableSub
	
	Dim j As HttpJob
	Dim bmp As B4XBitmap
	Dim strTiles As String = iZ & "/" & iX & "/" & iY & ".png"
	
	Try
		j.Initialize("", Me)
		j.Download("https://a.tile.openstreetmap.org/" & strTiles)
		
		'with this one downloading of tiles failed
		'-----------------------------------------
		'j.GetRequest.SetHeader("User-Agent","Mozilla/5.0 (Windows NT 6.1; WOW64; rv:27.0) Gecko/20100101 Firefox/27.0")
		j.GetRequest.SetHeader("User-Agent", "Mozilla/5.0 (iPad; U; CPU OS 3_2 like Mac OS X; en-us) AppleWebKit/531.21.10 (KHTML, like Gecko) Version/4.0.4 Mobile/7B334b Safari/531.21.102011-10-16 20:23:10")
		
		Wait For (j) JobDone(j As HttpJob)
		If j.Success Then
			Try
				bmp=j.GetBitmap
			Catch
				Log("no tile obtained!")
				Log(LastException.Message)
			End Try
		End If
	Catch
		Log("no connection to tile server!")
		Log(LastException.Message)
	End Try
	
	If j.IsInitialized Then
		j.Release
	End If
	
	Return bmp
	
End Sub

'Get Tile from SQLite DB
Public Sub getTileFromDB(iZ As Int,iX As Long,iY As Long) As B4XBitmap
	
	Dim strSQL As String
	Dim bmp As B4XBitmap
	
	strSQL = "select tile_data from tiles where zoom_level = ? and tile_column = ? and tile_row = ?"
	
	Try
		Dim rs As ResultSet = fDB.ExecQuery2(strSQL, Array As String(iZ,iX,iY))
		'Log(C.RowCount)
		If rs.NextRow Then
			Dim b() As Byte = rs.GetBlob2(0)
			Dim Ist As InputStream
			Ist.InitializeFromBytesArray(b,0,b.Length)
			#if B4A or b4i
			Dim i As Bitmap
			#else if B4J
				Dim i As Image
			#End If
			i.Initialize2(Ist)
			bmp=i
			Ist.Close
		End If
	Catch
		Log(LastException.Message)
	End Try
	
	If rs.IsInitialized Then
		rs.Close
	End If
	
	Return bmp
	
End Sub

'Set tile to DB
Public Sub setTileToDB(iZ As Int, lX As Long, lY As Long, aBmp As B4XBitmap) As Boolean
	
	Dim strSQL As String
	
	strSQL = "insert or replace into tiles(zoom_level, tile_column, tile_row, tile_data) values(?, ?, ?, ?)"
	
	Try
		Dim ost As OutputStream
		ost.InitializeToBytesArray(0)
		aBmp.WriteToStream(ost,70,"PNG")
		ost.close
		Dim b() As Byte=ost.ToBytesArray
		fDB.ExecNonQuery2(strSQL ,Array As Object(iZ,lX,lY,b))
		Return True
	Catch
		Log(LastException.Message)
		Return False
	End Try
	
End Sub

'delete from DB tiles from XY to XY and zoom and return how many records have been deleted
Public Sub DeleteTilesFromDB(iFromX As Int,iToX As Int,iFromY As Int,iToY As Int,iZoom As Int) As Long
	
	Dim strSQL As String
	Dim r As Long
	
	strSQL = "delete from t_tiles where tile_column between ? and ? and tile_row between ? and ? and zoom_level = ?"

	Try
		fDB.BeginTransaction
		fDB.ExecNonQuery2(strSQL, Array As String(Min(iFromX,iToY),Min(iFromY,iToY),Max(iFromX,iToX),Max(iFromY,iToY),iZoom))
		r=fDB.ExecQuerySingleResult("select changes()")
		fDB.TransactionSuccessful
		#if B4A
		fDB.EndTransaction
		#end if
		fDB.ExecNonQuery("vacuum")
	Catch
		Log(LastException.Message)
	End Try
	
	Return r
	
End Sub

'empty DB
Public Sub emptyDB As Long
	
	Dim r As Long
	
	Try
		fDB.BeginTransaction
		fDB.ExecNonQuery("delete from tiles")
		r = fDB.ExecQuerySingleResult("select changes()")
		fDB.TransactionSuccessful
		#if B4A
		fDB.EndTransaction
		#end if
		fDB.ExecNonQuery("vacuum")
	Catch
		Log(LastException.Message)
	End Try
	
	Return r
	
End Sub

Sub DownLoadTiles(BB As TMapBoxLatLng, iMinZoom As Int, iMaxZoom As Int, bEmptyTiles As Boolean, bShowProgress As Boolean) As ResumableSub 'ignore
	
	Dim x As Int
	Dim y As Int
	Dim z As Int
	Dim n As Int
	Dim p As Int
	Dim t As Int
	Dim dMinLat As Double = BB.fRightBottom.fLat
	Dim dMaxLat As Double = BB.fLeftTop.fLat
	Dim dMinLng As Double = BB.fLeftTop.fLng
	Dim dMaxLng As Double = BB.fRightBottom.fLng
	Dim iMinX As Int
	Dim iMaxX As Int
	Dim iMinY As Int
	Dim iMaxY As Int
	Dim iTilesTotal As Int
	Dim iProgressInterval As Int
	Dim iTilesRemoved As Int 'ignore
	Dim arrLong(2) As Long
	
	General.StartSW(2)

	iTilesTotal = MapUtilities.GetTotalTiles(BB, iMinZoom, iMaxZoom)
	
	If bShowProgress Then
		If iTilesTotal < 160 Then
			iProgressInterval = 1
		Else
			iProgressInterval = iTilesTotal / 100
		End If
	End If
	
	If bEmptyTiles Then
		iTilesRemoved = emptyDB
	End If
	
	If B4XProgressBar1.IsInitialized = False Then
		mParent.LoadLayout("ProgressBar")
	End If
	
	If bShowProgress Then
		B4XProgressBar1.Show(mParent, iTilesTotal, False, 1, "Tiles to download, ", "/", " done")
	End If
	
	fDB.BeginTransaction
	
	For z = iMinZoom To iMaxZoom
		iMinX = MapUtilities.LngToTileX(dMinLng, z)
		iMaxX = MapUtilities.LngToTileX(dMaxLng, z)
		iMinY = MapUtilities.LatToTileY(dMaxLat, z)
		iMaxY = MapUtilities.LatToTileY(dMinLat, z)
		'Log(iMinY & ", " & iMaxY)
		'iTilesForZoom = ((iMaxX - iMinX) + 1) * ((iMaxY - iMinY) + 1)
		'iTilesTotal = iTilesTotal + iTilesForZoom
		'Log(z & ", " & iTilesForZoom & ", " & iTilesTotal)
		'Log("Z: " & z & ", X: " & iMinX & " - " & iMaxX & ", Y: " & iMinY & " - " & iMaxY)
		For x = iMinX To iMaxX
			For y = iMinY To iMaxY
				Dim rs As ResumableSub = getTileFromInternet(z, x, y)
				Wait For (rs) Complete (b4xbmp As B4XBitmap)
				
				If b4xbmp.IsInitialized = False Then
					fDB.TransactionSuccessful
					fDB.EndTransaction
					If bShowProgress Then
						B4XProgressBar1.Reset
					End If
					Return arrLong
				End If
				
				If setTileToDB(z, x, y, b4xbmp) = False Then
					fDB.TransactionSuccessful
					fDB.EndTransaction
					If bShowProgress Then
						B4XProgressBar1.Reset
					End If
					Return arrLong
				End If
				
				n = n + 1
				p = p + 1
				t = t + 1
				
				If n = 10000 Then
					fDB.TransactionSuccessful
					fDB.EndTransaction
					n = 0
					fDB.BeginTransaction
				End If
				
				If bShowProgress Then
					If p = iProgressInterval Or t = 1 Then
						B4XProgressBar1.Progress = t
						p = 0
						Sleep(0)
					End If
				End If
			Next
		Next
	Next

	fDB.TransactionSuccessful
	fDB.EndTransaction
	
	If bShowProgress Then
		B4XProgressBar1.Reset
	End If
	
	arrLong(0) = t
	arrLong(1) = General.StopSW(2)
	
	Return arrLong
	
End Sub