﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=11.2
@EndOfDesignText@
'B4A=True
'Group=Default Group
'ModulesStructureVersion=1
'Type=Class
'Version=10.5
'@EndOfDesignText@
#region doc
'https://wiki.openstreetmap.org/wiki/Slippy_map_tilenames#X_and_Y
#end region

#region designer
#DesignerProperty: Key: centerLat, DisplayName: Latitude at center, FieldType: float, DefaultValue: 0
#DesignerProperty: Key: centerLng, DisplayName: Longitude at center, FieldType: float, DefaultValue: 0
#DesignerProperty: Key: zoomLevel, DisplayName: Zoom Level, FieldType: int, DefaultValue: 0,MinRange: 0, MaxRange: 17
#DesignerProperty: Key: compassDirection, DisplayName: Compass Direciton, FieldType: float, DefaultValue: 0,MinRange: 0, MaxRange: 360
#DesignerProperty: Key: offlineMode, DisplayName: Offline Mode, FieldType: boolean, DefaultValue: true
#DesignerProperty: Key: showMenu, DisplayName: Display Menu, FieldType: boolean, DefaultValue: false
#DesignerProperty: Key: showGrid, DisplayName: Display Grid, FieldType: boolean, DefaultValue: true
#DesignerProperty: Key: showCenter, DisplayName: Display Center, FieldType: boolean, DefaultValue: true
#DesignerProperty: Key: showLandmark, DisplayName: Display Landmark, FieldType: boolean, DefaultValue: false
#DesignerProperty: Key: showCenterLatLng, DisplayName: Display Lat/Lng, FieldType: boolean, DefaultValue: true
#DesignerProperty: Key: showZoom, DisplayName: Display Zoom, FieldType: boolean, DefaultValue: true
#DesignerProperty: Key: showScale, DisplayName: Display Scale, FieldType: boolean, DefaultValue: true
#DesignerProperty: Key: showCompass, DisplayName: Display Compass, FieldType: boolean, DefaultValue: true
#DesignerProperty: Key: showShapes, DisplayName: Display Shapes, FieldType: boolean, DefaultValue: true
#DesignerProperty: Key: showGPS, DisplayName: Display GPS, FieldType: boolean, DefaultValue: true
#DesignerProperty: Key: followGPS, DisplayName: Follow GPS, FieldType: boolean, DefaultValue: false

'RBS 02/05/2022
#DesignerProperty: Key: multiShapeClick, DisplayName: Get all clicked shapes, FieldType: boolean, DefaultValue: true

'UDG 26.04.2021
#DesignerProperty: Key: useTouch, DisplayName: Use touch, FieldType: boolean, DefaultValue: false, Description: true = use touch actions; false = use ShapesClicked
#DesignerProperty: Key: sensitivity, DisplayName: Click max interval, FieldType: int, DefaultValue: 500, MinRange: 100, MaxRange: 4000, Description: time in ms to complete any click action (single-double-long).
'original  events
#event:ready
#event:MenuClicked
#event:ScaleClicked(aScale as double)
#event:CenterlatlngClicked(alatLng as TLatLng)
#event:CenterLatLngChanged(aOldlatLng as TLatLng,aNewLatLng as TLatLng)
#event:zoomLevelChanged(aOldZzoomLEvel as int,aNewZoomLevel)
#event:compassDirectionChanged(aOldDirection as double, aNewDirection as double)
#event:compassClicked(adegres as double)
#event:shapesClicked(aLatLng as TMapLatLng, aShape as object)
#event:mapClicked(aLatLng as TMapLatLng)
#event:gpsClicked(aGPS as TMapGPS)
'UDG 26.04.2021
#event:mapLongClicked(aLatLng as TMapLatLng)
#event:mapDoubleClicked(aLatLng as TMapLatLng)
#end region

#region globals
Sub Class_Globals
	
'	Private iMaxTileY As Int
'	Private iMinTileY As Int
'	Private iMaxTileX As Int
'	Private iMinTileX As Int
	
	Private dMapHeightWidthFactor As Double
	Private mbFullMapCenterLines As Boolean
	Private miCenterLinesColour As Int
	Private mEventName As String 'ignore
	Private mCallBack As Object 'ignore
	Public mBase As B4XView
	Private fxui As XUI 'ignore
	Public Tag As Object
	'private constants
	'Private const cTileLayerImage As Int=0
	Private const cTileLayerGrid As Int = 1
	'private fields
	'Private cGPSWidth As Float=30dip
	'Private cGPSHeight As Float=30dip
	Private fMapTileManager As clsMapTileManager
	Private fMap As TMap
	Private fViewTilesAndTouch As B4XView
	Private fViewTiles As B4XView
	Private fViewTouch As B4XView
	Public fViewCenter As B4XView
	Private fViewLandmark As B4XView
	Private fViewCompass As B4XView
	Private fCompassBitmap(2) As B4XBitmap
	Private fTilesCount As Long
	Private fIsMoving As Boolean = False
	Private fViewCenterLatLng As B4XView
	Private fViewZoom As B4XView
	Private fViewZoomLevel As B4XView
	Private fViewScale As B4XView
	Private fViewScaleValue As B4XView
	Private fViewScaleRuler As B4XView
	Private fViewMenu As B4XView
	Private fLastTouch As TMapPoint
	Private fStartTouch As TMapPoint
	Private fViewCompassImage As B4XView
	Private fViewCompassBearing As B4XView
	Private fViewShapes As B4XView
	Private fShapeCanvas As B4XCanvas
	Private fViewGPS As B4XView
	Private fViewGPSImage As B4XView
	'UDG 26.04.2021
	Private mUseTouch As Boolean		'true = use touch actions for Click/DoubleClick/LongClick; false = use ShapesClick
	Private Sensitivity As Long 		'time in ms to complete any click action (single, double, long)
	Private ClickCount As Int			'number of clicks (press/release) counted during Sensitivity interval
	Private ClickTimer As Timer			'timer, used to differenziate between click and longclik
	Private ClickDown,ClickUp As Long	'time for first press down and last release up
	Private ClickedLL As TMapLatLng		'lat/long of clicked point on map
End Sub
#end region

#region initialization
Public Sub Initialize (Callback As Object, EventName As String)
	
	mEventName = EventName
	mCallBack = Callback
	fMap.Initialize
	fMap.fShapes.Initialize
	fLastTouch.Initialize
	fStartTouch.Initialize
	fMapTileManager.Initialize(Null)
	'UDG 26.04.2021
	ClickCount = -1
	ClickTimer.Initialize("ctm",100)		'check click state every 100ms
	
End Sub

'on base resize event
Private Sub Base_Resize (Width As Double, Height As Double)
	If fViewTilesAndTouch.IsInitialized Then
		mBase.RemoveAllViews
		Rearrange
		Draw
	End If
End Sub

'Base type must be Object
Public Sub DesignerCreateView (Base As Object, Lbl As Label, Props As Map)
	mBase = Base
	Tag = mBase.Tag
	mBase.Tag = Me
	CallSubDelayed2(Me,"LoadLayout",Props)
End Sub

Public Sub ClearShapes
	fMap.fShapes.Initialize
End Sub

'load layout and raise ready event
private Sub LoadLayout(aProps As Map)
	
	Rearrange
	'init B4XBitmap for compass
	fCompassBitmap(0)=fxui.LoadBitmapResize(File.DirAssets,"compass0.png",fViewCompassImage.Width,fViewCompassImage.Height,True)
	fCompassBitmap(1)=fxui.LoadBitmapResize(File.DirAssets,"compassx.png",fViewCompassImage.Width,fViewCompassImage.Height,True)
	
	'init map info and options from custom properties
	fMap.Initialize
	fMap.fGPS = MapUtilities.initGPS(MapUtilities.initLatLng(MapUtilities.tMapCentre.fLat, MapUtilities.tMapCentre.fLng), 0)
	
	setCenterLatLng(MapUtilities.initLatLng(aProps.GetDefault("centerLat",0),aProps.GetDefault("centerLng",0)))
	setZoomLevel(aProps.GetDefault("zoomLevel",0))
	setCompassDirection(aProps.GetDefault("compassDirection",0))
	setShowCenter(aProps.GetDefault("showCenter",True))
	setOfflineMode(aProps.GetDefault("offlineMode",False))
	setShowMenu(aProps.GetDefault("showMenu",True))
	setShowGrid(aProps.GetDefault("showGrid",True))
	setShowLandmark(aProps.GetDefault("showLandmark",True))
	setShowCenterLatLng(aProps.GetDefault("showCenterLatLng",True))
	setShowZoom(aProps.GetDefault("showZoom",True))
	setShowScale(aProps.GetDefault("showScale",True))
	setShowCompass(aProps.GetDefault("showCompass",True))
	setShowShapes(aProps.GetDefault("showMarkers",True))
	setShowGPS(aProps.GetDefault("showGPS",True))
	setFollowGPS(aProps.GetDefault("followGPS",False))
	
	'RBS 02/05/2022
	setmultiShapeClick(aProps.GetDefault("multiShapeClick",True))
	
	'UDG 26.04.2021
	Sensitivity = aProps.GetDefault("sensitivity", 500)
	mUseTouch = aProps.GetDefault("useTouch", False)
	
	'raise event ready
	If SubExists(mCallBack, mEventName & "_ready") Then
		CallSub(mCallBack, mEventName & "_ready")
	End If
	
	'so we can see what view is added to what
	'----------------------------------------
	mBase.Tag = "Base"
	fViewCenter.Tag = "fViewCenter"
	fViewShapes.Tag = "fViewShapes"
	fViewTiles.Tag = "fViewTiles"
	fViewTilesAndTouch.Tag = "fViewTilesAndTouch"
	fViewTouch.Tag = "fViewTouch"
	
	dMapHeightWidthFactor = mBase.Height / mBase.Width
	'Log("dMapHeightWidthFactor: " & dMapHeightWidthFactor)
	
End Sub

Public Sub ClearCenterLines

	Dim c As B4XCanvas
	
	c.Initialize(fViewCenter)
	c.ClearRect(c.TargetRect)
	c.Invalidate
	
End Sub

Public Sub DrawCenterLines(iColor As Int, fStrokeWidth As Float, bFullLines As Boolean, bDrawAgain As Boolean)

	Dim c As B4XCanvas
	
	If bDrawAgain = False Then
		If miCenterLinesColour = iColor Then
			If mbFullMapCenterLines = bFullLines Then
				Return
			End If
		End If
	End If
	
	Sleep(0)
	c.Initialize(fViewCenter)
	c.ClearRect(c.TargetRect)
	'altered RBS from circle to cross hairlines 13/02.2022
	'------------------------------------------------------
	'c.DrawCircle(fViewCenter.Width/2, fViewCenter.Height/2, 10dip,fxui.Color_Red, False, 2dip)
	
	If bFullLines Then
		c.DrawLine(0, fViewCenter.Height/2, fViewCenter.Left + fViewCenter.Width, fViewCenter.Height/2, _
				   iColor, fStrokeWidth * 1dip) 'horizontal
		c.DrawLine(fViewCenter.Width / 2, 0, fViewCenter.Width / 2, fViewCenter.Height, _
				   iColor, fStrokeWidth * 1dip) 'vertical
	Else
		c.DrawLine(fViewCenter.Width / 2 - 24dip, fViewCenter.Height/2, fViewCenter.Width / 2 + 24dip, fViewCenter.Height/2, _
				   iColor, fStrokeWidth * 1dip) 'horizontal
		c.DrawLine(fViewCenter.Width / 2, fViewCenter.Height/2 - 24dip, fViewCenter.Width / 2, fViewCenter.Height/2 + 24dip, _
				   iColor, fStrokeWidth * 1dip) 'vertical
	End If

	c.Invalidate
	
	miCenterLinesColour = iColor
	mbFullMapCenterLines = bFullLines

End Sub

Public Sub DrawEdges(tMBLL As TMapBoxLatLng, iColor As Int, fStrokeWidth As Float)
	
	Dim c As B4XCanvas
	Dim tMP_LeftTop As TMapPoint
	Dim tMP_RightBottom As TMapPoint
	Dim dLeft As Double
	Dim dRight As Double
	Dim dTop As Double
	Dim dBottom As Double
	
	tMP_LeftTop = LatLngToPoint(tMBLL.fLeftTop)
	tMP_RightBottom = LatLngToPoint(tMBLL.fRightBottom)
	
	dLeft = tMP_LeftTop.fX
	dTop = tMP_LeftTop.fY
	dRight = tMP_RightBottom.fX
	dBottom = tMP_RightBottom.fY
	
	c.Initialize(fViewCenter)
	
	'top edge
	c.DrawLine(dLeft, dTop, dRight, dTop, iColor, fStrokeWidth * 1dip)
	'bottom edge
	c.DrawLine(dLeft, dBottom, dRight, dBottom, iColor, fStrokeWidth * 1dip)
	'left edge
	c.DrawLine(dLeft, dTop, dLeft, dBottom, iColor, fStrokeWidth * 1dip)
	'right edge
	c.DrawLine(dRight, dTop, dRight, dBottom, iColor, fStrokeWidth * 1dip)
	
	c.Invalidate

End Sub

Private Sub Rearrange
	
	mBase.LoadLayout("cvmap")
	
	'calc diag of map and resize panel
	Dim diag As Double = Sqrt(Power(mBase.Width,2) + Power(mBase.Height, 2))
	
	'this will be 2064.945519862449
	
	fViewTilesAndTouch.Width=diag
	fViewTilesAndTouch.Height=diag
	fViewTilesAndTouch.Left=-(fViewTilesAndTouch.Width-mBase.Width)/2
	fViewTilesAndTouch.Top=-(fViewTilesAndTouch.Height-mBase.Height)/2
	fViewTouch.Width=fViewTilesAndTouch.Width
	fViewTouch.Height=fViewTilesAndTouch.Height
	fViewTiles.Width=fViewTilesAndTouch.Width
	fViewTiles.Height=fViewTilesAndTouch.Height
	fViewCenter.Width=fViewTilesAndTouch.Width
	fViewCenter.Height=fViewTilesAndTouch.Height
	fViewLandmark.Width=fViewTilesAndTouch.Width
	fViewLandmark.Height=fViewTilesAndTouch.Height
	fViewShapes.Width=fViewTilesAndTouch.Width
	fViewShapes.Height=fViewTilesAndTouch.Height
	fViewGPS.Width=fViewTilesAndTouch.Width
	fViewGPS.Height=fViewTilesAndTouch.Height
	
'	'draw center on fpanelcenter
'	Dim c As B4XCanvas
'	c.Initialize(fViewCenter)
'	'altered RBS from circle to cross hairlines 13/02.2022
'	'------------------------------------------------------
'	'c.DrawCircle(fViewCenter.Width/2,fViewCenter.Height/2,10dip,fxui.Color_Red,False,2dip)
'	c.DrawLine(0, fViewCenter.Height/2, fViewCenter.Left + fViewCenter.Width, fViewCenter.Height/2, Colors.Red, 1dip)
'	c.DrawLine(fViewCenter.Width / 2, 0, fViewCenter.Width / 2, fViewCenter.Height,Colors.Red, 1dip)
'	c.Invalidate
	
	'draw landmark on fpanellandmark
	Dim c As B4XCanvas
	c.Initialize(fViewLandmark)
	c.DrawLine(fViewLandmark.Width/2,0,fViewLandmark.Width/2,fViewLandmark.Height,fxui.Color_Red,1dip)
	c.DrawLine(0,fViewLandmark.Height/2,fViewLandmark.Width,fViewLandmark.Height/2,fxui.Color_Red,1dip)
	c.Invalidate
	
	'initialize canvas for shapes
	fShapeCanvas.Initialize(fViewShapes)
	
End Sub
#end region

#region setter/getter
Public Sub setShowMenu(avalue As Boolean)
	fMap.fShowMenu=avalue
	fViewMenu.Visible=avalue
End Sub

Public Sub getShowMenu As Boolean
	Return fMap.fShowMenu
End Sub

Public Sub setShowGrid(avalue As Boolean)
	fMap.fShowGrid=avalue
	ShowHideTileLayer(cTileLayerGrid,avalue)
End Sub

Public Sub getShowGrid As Boolean
	Return fMap.fShowGrid
End Sub

Public Sub setShowCenter(avalue As Boolean)
	fMap.fShowCenter=avalue
	fViewCenter.Visible=avalue
End Sub

Public Sub getShowCenter As Boolean
	Return fMap.fshowCenter
End Sub

Public Sub setShowShapes(avalue As Boolean)
	fMap.fShowShapes=avalue
	fViewShapes.Visible=avalue
End Sub

Public Sub getShowShapes As Boolean
	Return fMap.fShowShapes	
End Sub

Public Sub setShowGPS(avalue As Boolean)
	'Log("setShowGPS: " & avalue)
	fMap.fShowGPS=avalue
	fViewGPS.Visible=avalue
End Sub

Public Sub getShowGPS As Boolean
	Return fMap.fShowGPS
End Sub

Public Sub setFollowGPS(avalue As Boolean)
	fMap.fFollowGPS=avalue
End Sub

Public Sub getFollowGPS As Boolean
	Return fMap.fFollowGPS
End Sub

Public Sub setShowLandmark(avalue As Boolean)
	fMap.fShowLandmark=avalue
	fViewLandmark.Visible=avalue
End Sub

Public Sub getShowLandmark As Boolean
	Return fMap.fShowLandmark
End Sub

Public Sub setShowCenterLatLng(avalue As Boolean)
	fMap.fShowCenterLatLng=avalue
	fViewCenterLatLng.Visible=avalue
End Sub

Public Sub getShowCenterLatLng As Boolean
	Return fMap.fShowCenterLatLng
End Sub

Public Sub setShowZoom(avalue As Boolean)
	fMap.fShowZoom=avalue
	fViewZoom.Visible=avalue
End Sub

Public Sub getShowZoom As Boolean
	Return fMap.fShowZoom
End Sub

Public Sub setShowScale(avalue As Boolean)
	fMap.fShowScale=avalue
	fViewScale.Visible=avalue
End Sub

Public Sub getShowScale As Boolean
	Return fMap.fShowScale
End Sub

Public Sub setOfflineMode(avalue As Boolean)
	fMap.fOfflineMode=avalue
	fMapTileManager.Offline=avalue
End Sub

Public Sub getOfflineMode As Boolean
	Return fMap.fOfflineMode
End Sub

Public Sub setShowCompass(avalue As Boolean)
	fMap.fShowCompass=avalue
	fViewCompass.Visible=avalue
End Sub

Public Sub getShowCompass As Boolean
	Return fMap.fshowCompass
End Sub

Public Sub setZoomLevel(avalue As Int)
	fMap.fZoomLevel=MapUtilities.validZoomLevel(avalue)
	fViewTiles.RemoveAllViews
	fTilesCount=Power(2,fMap.fZoomLevel)
	fViewZoomLevel.Text=$"${fMap.fZoomLevel}/${MapUtilities.iMaxZoomLevel}"$
	If SubExists(mCallBack,mEventName & "_zoomLevelChanged") Then
		CallSub2(mCallBack,mEventName & "_zoomLevelChanged",fMap.fZoomLevel)
	End If
End Sub

Public Sub getZoomLevel As Int
	Return fMap.fZoomLevel
End Sub

Public Sub setCompassDirection(avalue As Double)
	If avalue=fMap.fCompassDirection Then
		Return
	End If
	fMap.fCompassDirection=MapUtilities.validCompassDirection(avalue)
	Update_CompassDirection
End Sub

Public Sub getCompassDirection As Double
	Return fMap.fCompassDirection
End Sub

Public Sub setCenterLatLng(avalue As TMapLatLng)
	fMap.fCenterLatLng.fLat = MapUtilities.validLat(avalue.fLat)
	fMap.fCenterLatLng.fLng = MapUtilities.validLng(avalue.fLng)
	fViewTiles.removeAllViews
	Update_CenterLatLng
End Sub

Public Sub getCenterLatLng As TMapLatLng
	Return fMap.fCenterLatLng
End Sub

'RBS added 02/05/2022
Public Sub setmultiShapeClick(bMultiShapeClick As Boolean)
	fMap.bMultiShapeClick = bMultiShapeClick
End Sub

Public Sub getmultiShapeClick As Boolean
	Return fMap.bMultiShapeClick
End Sub
#end region

#region Show/Hide layer
private Sub ShowHideTileLayer(aLayer As Int,aShowHide As Boolean)
	For i=0 To fViewTiles.NumberOfViews-1
		Dim pt As B4XView=fViewTiles.GetView(i)
		Dim pm As B4XView=pt.GetView(aLayer)
		pm.Visible=aShowHide
	Next
End Sub
#end region

#region draw Map
Public Sub Draw
	
	CreateTiles(fMap.fCenterLatLng, fMap.fZoomLevel)
	Update_Scale
	Update_CompassDirection
	Update_CenterLatLng
	Update_shapes
	Update_GPS
	
End Sub
#end region

#region conversion Map, Center, Point, X/Y, Lat/Lng, Tile
'return tile which contains point X/Y
Private Sub PointToTile(aX As Int,aY As Int) As B4XView
	For i=0 To fViewTiles.NumberOfViews-1
		Dim t As B4XView=fViewTiles.GetView(i)
		If (t.Left<=aX) And (t.Left+t.Width>=aX) And (t.Top<=aY) And (t.Top+t.Height>=aY) Then
			Return t
		End If
	Next
	Return Null
End Sub

'return X tile and offset for this lng
Public Sub LngToTileX(aLng As Double,aZoom As Int) As TMapTileNumberOffset
	Dim v As Double=(aLng+180)/360*Power(2,aZoom)
	Dim t As TMapTileNumberOffset
	t.Initialize
	t.fTile=Floor(v)
	t.fOffset=(v-t.fTile)*MapUtilities.cTileSize
	Return t
End Sub

'return Y tile and offset for this lat
Public  Sub LatToTileY(aLat As Double,aZoom As Int) As TMapTileNumberOffset
	Dim v As Double=(1-Logarithm(TanD(aLat)+1/CosD(aLat),cE)/cPI)/2*Power(2,aZoom)
	Dim t As TMapTileNumberOffset
	t.Initialize
	t.fTile=Floor(v)
	t.fOffset=(v-t.fTile)*MapUtilities.cTileSize
	Return t
End Sub

'return lng for X tile and offset
Public Sub TileXToLng(aX As Double,aOffsetX As Double,aZoom As Int) As Double
	Dim n As Double=Power(2,aZoom)
	Dim v As Double=(aX+aOffsetX/MapUtilities.cTileSize)/n*360.0-180.0
	Return v
End Sub

'return lat for Y tile and offset
Public Sub TileYToLat(aY As Double,aOffsetY As Double,aZoom As Int) As Double
	Dim n As Double=cPI-2*cPI*(aY+aOffsetY/MapUtilities.cTileSize)/Power(2,aZoom)
	Dim v As Double=(180.0/cPI*ATan(0.5*(Power(cE,n)-Power(cE,-n))))
	Return v
End Sub

'return the tile (view) which is number X and Y
private Sub XYToTile(aX As Long,aY As Long) As B4XView
	
	For i = 0 To fViewTiles.NumberOfViews-1
		Dim v As B4XView = fViewTiles.GetView(i)
		Dim t As TMapTileXY = v.Tag
		If t.fX = aX And t.fY = aY Then
			Return v
		End If
	Next
	
	Return Null
	
End Sub

'return lat/lng from center map
Public Sub MapCenterToLatLng As TMapLatLng
	Return PointToLatLng(MapUtilities.initPoint(fViewTouch.Width/2, fViewTouch.Height/2))
End Sub

Public Sub GetLatLonEdgesOfMapScreen(dLatMarginFactor As Double) As TMapBoxLatLng

	Dim tLLLeftTop As TMapLatLng
	Dim tLLRightBottom As TMapLatLng
	Dim dLngMarginFactor As Double
	Dim tMBLL As TMapBoxLatLng
	
	dLngMarginFactor = dLatMarginFactor / dMapHeightWidthFactor
	
	'Log("mBase.Parent.Tag: " & mBase.Parent.Tag) 'will be pnlMap
	
	'fViewTilesAndTouch.Left remains the same when moving the map!
	'-------------------------------------------------------------
	'Log("fViewTilesAndTouch.Left :" & fViewTilesAndTouch.Left & ", fViewTilesAndTouch.Top: " & fViewTilesAndTouch.Top)
	
	'mBase.Left remains the same when moving the map!
	'-------------------------------------------------------------
	'Log("mBase.Left :" & mBase.Left & ", mBase.Top: " & mBase.Top)
	
	If dLatMarginFactor = 0 Then
		tLLLeftTop = PointToLatLng(MapUtilities.initPoint(fViewCenter.Left - fViewTilesAndTouch.Left, _
													  	  fViewCenter.Top - fViewTilesAndTouch.Top))
		tLLRightBottom = PointToLatLng(MapUtilities.initPoint((fViewCenter.Left - fViewTilesAndTouch.Left) + mBase.Width, _
														  	  (fViewCenter.Top - fViewTilesAndTouch.Top) + mBase.Height))
	Else
		tLLLeftTop = PointToLatLng(MapUtilities.initPoint(mBase.Width / dLngMarginFactor + (fViewCenter.Left - fViewTilesAndTouch.Left), _
													  	  mBase.Height / dLatMarginFactor + (fViewCenter.Top - fViewTilesAndTouch.Top)))
		tLLRightBottom = PointToLatLng(MapUtilities.initPoint((fViewCenter.Left - fViewTilesAndTouch.Left) + mBase.Width - (mBase.Width / dLngMarginFactor), _
														  	  (fViewCenter.Top - fViewTilesAndTouch.Top) + mBase.Height - (mBase.Height / dLatMarginFactor)))
	End If
	
	tMBLL.fLeftTop = tLLLeftTop
	tMBLL.fRightBottom = tLLRightBottom
	
	Return tMBLL
	
End Sub

'return  TMapPoint from TMapLatLng
Public Sub LatLngToPoint(aLatLng As TMapLatLng) As TMapPoint
	
	'https://www.netzwolf.info/osm/tilebrowser.html?marker.x=12&marker.y=189&tx=1&ty=0&tz=1&ts=256#tile
	Dim v As B4XView=PointToTile(0,0)
	Dim txy As TMapTileXY=v.tag
	Dim gpx As Double=(txy.fX+(-v.Left/MapUtilities.cTileSize))/Power(2,fMap.fZoomLevel)
	Dim gpy As Double=(txy.fy+(-v.top/MapUtilities.cTileSize))/Power(2,fMap.fZoomLevel)
	Dim tx As TMapTileNumberOffset=LngToTileX(aLatLng.fLng,fMap.fZoomLevel) '<<<<< Caused by: java.lang.NullPointerException: Attempt to read from field 'double b4a.sqlitelight1.maputilities$_tmaplatlng.fLng' on a null object reference
	Dim ty As TMapTileNumberOffset=LatToTileY(aLatLng.fLat,fMap.fZoomLevel)
	Dim ppx As Double=(tx.fTile+(tx.fOffset/MapUtilities.cTileSize))/Power(2,fMap.fZoomLevel)
	Dim ppy As Double=(ty.fTile+(ty.fOffset/MapUtilities.cTileSize))/Power(2,fMap.fZoomLevel)
	Dim p As TMapPoint=MapUtilities.initPoint(fTilesCount*MapUtilities.cTileSize*(ppx-gpx),fTilesCount*MapUtilities.cTileSize*(ppy-gpy))
	
	Return p
	
End Sub

'return lat/lng from point on map
Public Sub PointToLatLng(aPoint As TMapPoint) As TMapLatLng

	Dim ll As TMapLatLng
	ll.Initialize
	Dim ti As B4XView = PointToTile(aPoint.fX, aPoint.fY)
	If ti.IsInitialized Then
		Dim txy As TMapTileXY = ti.tag
		ll.fLng = TileXToLng(txy.fX, aPoint.fX - ti.left, fMap.fZoomLevel)
		ll.fLat = TileYToLat(txy.fy, aPoint.FY - ti.top, fMap.fZoomLevel)
	Else
		'Log("pointtolatlng not found "  & aPoint.fX & " | " & aPoint.fy)
		ll.fLat = 0
		ll.fLng = 0
	End If
	Return ll
	
End Sub
#end region

#region update_map
Public Sub Update_Scale
	Dim m As Double=CalcScale(fMap.fCenterLatLng.fLat,fMap.fZoomLevel)
	fViewScale.SetLayoutAnimated(0,5dip,mBase.Height-45dip,138dip,40dip)
	fViewScaleRuler.SetLayoutAnimated(0,5dip,30dip,128dip,5dip)
	fViewScaleValue.SetLayoutAnimated(0,5dip,5dip,128dip,20dip)
	fViewScaleValue.Text=DistanceStr(m/2)
End Sub

Public Sub Update_CompassDirection
	fViewCompassImage.Rotation=fMap.fCompassDirection
	fViewCompassBearing.Text=$"$1.0{fMap.fCompassDirection}°"$
	If fMap.fCompassDirection=0 Then
		fViewCompassImage.SetBitmap(fCompassBitmap(0))
	Else
		fViewCompassImage.SetBitmap(fCompassBitmap(1))
	End If
	fViewTilesAndTouch.Rotation=fMap.fCompassDirection
	If SubExists(mCallBack,mEventName & "_compassDirectionChanged") Then
		CallSub2(mCallBack,mEventName & "_compassDirectionChanged",fMap.fCompassDirection)
	End If
End Sub

Public Sub Update_CenterLatLng
	
	If fViewCenterLatLng.IsInitialized Then
		fViewCenterLatLng.Text=$"Lat : ${NumberFormat2(fMap.fCenterLatLng.fLat,1,5,5,False)} | Lng : ${NumberFormat2(fMap.fCenterLatLng.fLng,1,5,5,False)}"$
	End If
	If SubExists(mCallBack,mEventName & "_centerLatLngChanged") Then
		CallSub2(mCallBack,mEventName & "_centerLatLngChanged",fMap.fCenterLatLng)
	End If
	
End Sub
#end region

#region create/draw tiles
'load image and set bitmap to tile
Public Sub DrawTile(aImageTile As B4XView,aZ As Int,aX As Long,aY As Long)

	wait for (fMapTileManager.getTile(aZ,aX,aY)) complete (result As B4XBitmap)
	Try
		aImageTile.setBitmap(result)
	Catch
		Log(LastException.Message)
	End Try
	
End Sub

'return tile in interval 0..fTilesCount-1
private Sub CheckTile(aTile As Int,aTilesNumber As Int) As Int
	If aTile<0 Then
		aTile=aTilesNumber+aTile
	End If
	Return (aTile Mod aTilesNumber)
End Sub

'add tile to the mapview
private Sub AddTile(aLeft As Int,aTop As Int,aTileX As Long,aTileY As Long,aZ As Int)
	
	Dim bTileInDB As Boolean
	
	bTileInDB = MapUtilities.TileInDB(aZ,aTileX,aTileY)
	
	'Log("AddTile, before checkTile, aTileX: " & aTileX & ", aTileY: " & aTileY)
	
	'fTilesCount is determined by the zoom level, checkTile will normally return the same number that was passed
	'-----------------------------------------------------------------------------------------------------------
	If bTileInDB Then '<<<< added RBS 14/03/2022
		aTileX=CheckTile(aTileX,fTilesCount)
		aTileY=CheckTile(aTileY,fTilesCount)
	End If
	
	'Log("addTile, after checkTile, aTileX: " & aTileX & ", aTileY: " & aTileY)
	
	'view for the tile
	Dim xpt As B4XView = fxui.CreatePanel("tile")
	xpt.Tag=MapUtilities.initTileXY(aTileX,aTileY)
	fViewTiles.AddView(xpt,aLeft,aTop,MapUtilities.cTileSize,MapUtilities.cTileSize)
	
	'view for the tile's image
	'only put image on tile panel if that tile is in the DB
	'------------------------------------------------------
	If bTileInDB Then '<<<< added RBS 14/03/2022
		Dim iv As ImageView
		iv.Initialize("itile")
		xpt.AddView(iv,0,0,MapUtilities.cTileSize,MapUtilities.cTileSize)
		DrawTile(iv,aZ,aTileX,aTileY)
	End If
	
	'view for the grid
	If fMap.fShowGrid Then '<<<< added RBS 14/03/2022
		Dim pg As B4XView = fxui.CreatePanel("gtile")
		xpt.AddView(pg,0,0,MapUtilities.cTileSize,MapUtilities.cTileSize)
		DrawGridOnTile(pg)
		pg.Visible=fMap.fShowGrid
	End If
	
End Sub

'draw grid on the tile grid layer
private Sub DrawGridOnTile(aView As B4XView)
	Dim c As B4XCanvas
	c.Initialize(aView)
	c.ClearRect(c.TargetRect)
	c.DrawLine(c.TargetRect.Width/2,0,c.TargetRect.Width/2,c.TargetRect.Height,fxui.Color_DarkGray,1dip)
	c.DrawLine(0,c.TargetRect.height/2,c.TargetRect.width,c.TargetRect.Height/2,fxui.Color_DarkGray,1dip)
	c.DrawRect(c.TargetRect,fxui.Color_Black,False,1dip)
	c.invalidate
End Sub

'create all tiles
private Sub CreateTiles(aLatLng As TMapLatLng, aZoom As Int)
	
	'retrieve tile X/Y and offset X/Y from lat/lng
	Dim x As TMapTileNumberOffset=LngToTileX(aLatLng.fLng,aZoom)
	Dim y As TMapTileNumberOffset=LatToTileY(aLatLng.fLat,aZoom)
	Dim l As Int=(fViewTiles.Width/2)-x.fOffset
	Dim t As Int=fViewTiles.height/2-y.fOffset
	
'	Log("x.fOffset: " & x.fOffset)
'	Log("y.fOffset: " & y.fOffset)
'	Log("aZoom: " & aZoom)
'	Log("aLatLng.fLat: " & aLatLng.fLat)
'	Log("aLatLng.fLng: " & aLatLng.fLng)

'	iMaxTileX = 0
'	iMaxTileY = 0
'	iMinTileX = 100000000
'	iMinTileY = 100000000

	'check if tile X/Y exists
	Dim txy As B4XView=XYToTile(x.fTile,y.fTile)
	
	If txy.IsInitialized Then
		'if True, just move tiles
		'moveTiles(100,l-txy.Left,t-txy.Top)
		MoveTiles(0, l-txy.Left, t-txy.Top)
	Else
		'else remove all and create all tiles
		'get first left/top tile to draw
		Do While (l>0)
			l=l-Floor(MapUtilities.cTileSize)
			x.fTile=x.fTile-1
		Loop
		
		Do While (t>0)
			t=t-Floor(MapUtilities.cTileSize)
			y.fTile=y.fTile-1
		Loop

		'remove all tiles
		fViewTiles.RemoveAllViews
		
		'add all tiles
		Dim ti As Int
		Dim lj As Int
		Dim ty As Int
		Dim tx As Int
		lj=l
		tx=x.fTile
		
		'check timings here
		'General.StartSW(2)
		Do While (lj<fViewTiles.Width)
			ti=t
			ty=y.fTile
			Do While (ti<fViewTiles.Height)
				AddTile(lj,ti,tx,ty,fMap.fZoomLevel)
				'Log("Create tiles, tx: " & tx & ", ty: " & ty)
				
'				If tx > iMaxTileX Then
'					iMaxTileX = tx
'				Else
'					If tx < iMinTileX Then iMinTileX = tx
'				End If
'				
'				If ty > iMaxTileY Then
'					iMaxTileY = ty
'				Else
'					If ty < iMinTileY Then iMinTileY = ty
'				End If

				ti=ti+MapUtilities.cTileSize
				ty=ty+1
			Loop
			lj=lj+MapUtilities.cTileSize
			tx=tx+1
		Loop
		'Log(General.FormatMilliSecs(General.StopSW(2)))
		
	End If
	
End Sub
#end region

#region move tiles
'move tiles up and down, remove invisible tiles, add missing visible tiles
Private Sub MoveTilesY(aduration As Int,aMoveY As Int)
	
	'is there any point in setting aduration > 0?
	'--------------------------------------------
	Dim ti As TMapTileXY
	Dim y As Int
	Dim r As List
	
	r.Initialize
	
	For i = 0 To fViewTiles.NumberOfViews - 1
		Dim t As B4XView=fViewTiles.GetView(i)
		If t.top+aMoveY+MapUtilities.cTileSize<0 Then
			r.Add(t)
		Else
			If t.top+aMoveY>fViewTiles.Height Then
				r.Add(t)
			Else
				y=t.top
				t.SetLayoutAnimated(aduration,t.left,t.top+aMoveY,MapUtilities.cTileSize,MapUtilities.cTileSize)
				ti=t.tag
				If (y<=0) And (t.top>0) Then
					AddTile(t.Left,t.top-MapUtilities.cTileSize,ti.fX,ti.fy-1,fMap.fZoomLevel)
					'Log("MoveTilesY, ti.fX: " & ti.fX & ", ti.fY: " & ti.fY)
				Else
					If (y+MapUtilities.cTileSize>=fViewTiles.height) And (t.top+MapUtilities.cTileSize<fViewTiles.height) Then
						AddTile(t.Left,t.top+MapUtilities.cTileSize,ti.fX,ti.fy+1,fMap.fZoomLevel)
						'Log("MoveTilesY, ti.fX: " & ti.fX & ", ti.fY: " & ti.fY)
					End If
				End If
			End If
		End If
	Next
	
	For Each t As B4XView In r
		t.RemoveViewFromParent
	Next
	
End Sub

'move tiles left and right, remove invisible tiles, add missing visible tiles
Private Sub MoveTilesX(aduration As Int,aMoveX As Int)
	
	Dim ti As TMapTileXY
	Dim x As Int
	Dim r As List
	
	r.Initialize
	For i=0 To fViewTiles.NumberOfViews-1
		Dim t As B4XView=fViewTiles.GetView(i)
		If t.Left+aMoveX+MapUtilities.cTileSize<0 Then
			r.Add(t)
		Else
			If t.Left+aMoveX>fViewTiles.Width Then
				r.Add(t)
			Else
				x=t.left
				t.SetLayoutAnimated(aduration,t.left+aMoveX,t.top,MapUtilities.cTileSize,MapUtilities.cTileSize)
				ti=t.tag
				If (x<=0) And (t.Left>0) Then
					AddTile(t.Left-MapUtilities.cTileSize,t.top,ti.fX-1,ti.fy,fMap.fZoomLevel)
					'Log("MoveTilesX, ti.fX: " & ti.fX & ", ti.fY: " & ti.fY)
				Else
					If (x+MapUtilities.cTileSize>=fViewTiles.width) And (t.Left+MapUtilities.cTileSize<fViewTiles.Width) Then
						AddTile(t.Left+MapUtilities.cTileSize,t.top,ti.fX+1,ti.fy,fMap.fZoomLevel)
						'Log("MoveTilesX, ti.fX: " & ti.fX & ", ti.fY: " & ti.fY)
					End If
				End If
			End If
		End If
	Next
	
	For Each t As B4XView In r
		t.RemoveViewFromParent
	Next
	
End Sub

'move tiles
private Sub MoveTiles(aduration As Int,aMoveX As Int,aMoveY As Int)
	
	'move tiles
	MoveTilesX(aduration,aMoveX)
	MoveTilesY(aduration,aMoveY)
	Dim v As B4XView=fViewTiles.GetView(0)
	#if B4i
		Dim l As Int=Bit.FMod(v.Left, MapUtilities.cTileSize)
	Dim t As Int=Bit.FMod(v.Top,MapUtilities.cTileSize)
	#Else 
		Dim l As Int=v.Left Mod MapUtilities.cTileSize
		Dim t As Int=v.Top Mod MapUtilities.cTileSize
	#End If
	
	If l<-MapUtilities.cTileSize Then
		l=l+MapUtilities.cTileSize
	End If
	If t<-MapUtilities.cTileSize Then
		t=t+MapUtilities.cTileSize
	End If
	
End Sub
#end region

#region Map
Public Sub setMap(aMap As TMap)
	
	setCenterLatLng(aMap.fCenterLatLng)
	setCompassDirection(aMap.fCompassDirection)
	setZoomLevel(aMap.fZoomLevel)
	setOfflineMode(aMap.fOfflineMode)
	setShowCenter(aMap.fshowCenter)
	setShowCenterLatLng(aMap.fShowCenterLatLng)
	setShowCompass(aMap.fShowCompass)
	setShowGrid(aMap.fShowGrid)
	setShowLandmark(aMap.fShowLandmark)
	setShowShapes(aMap.fShowShapes)
	setShowMenu(aMap.fShowMenu)
	setShowScale(aMap.fShowScale)
	setShowZoom(aMap.fShowZoom)
	setShowGPS(aMap.fShowGPS) '<<< this was missing
	fMap.fShapes=aMap.fShapes
	
End Sub

Public Sub getMap As TMap
	Return fMap
End Sub
#end region

#region zoom
'zoom in/out and raise event zoomChanged
private Sub fViewZoomInOut_click
	Dim b As Button=Sender
	
	If fMap.fCenterLatLng.fLat > 52.7 Then Return
	
	setZoomLevel(fMap.fZoomLevel + b.Tag)
	CreateTiles(fMap.fCenterLatLng,fMap.fZoomLevel)
	Update_Scale
	Update_shapes
	Update_GPS
	
End Sub

Private Sub fViewZoom_Touch (Action As Int, X As Float, Y As Float) As Boolean
	Return True
End Sub
#end region

#region scale
'format a distance (m or km)
private Sub DistanceStr(aDistance As Double) As String
	If aDistance>1000 Then
		Return NumberFormat2(aDistance/1000,1,0,0,False) & "Km"
	Else
		Return NumberFormat2(aDistance,1,0,0,False) & "m"
	End If
End Sub

'calc distance for 128dip (horizontal) at this latitude and this zoom level
private Sub CalcScale(aLatitude As Double,aZoom As Int) As Double
	Return 40075016.686*Cos(aLatitude*cPI/180)/Power(2,aZoom)
End Sub


'raise event scaleClicked
#if B4A or B4i
	Private Sub fViewScale_Click
		Dim ll As TMapLatLng=MapCenterToLatLng
		Dim s As Double=CalcScale(ll.fLat,fMap.fZoomLevel)
		If SubExists(mCallBack,mEventName & "_scaleClicked") Then
			CallSub2(mCallBack,mEventName & "_scaleClicked",s)
		End If	
	End Sub
#else if b4j
	Private Sub fViewScale_MouseClicked (EventData As MouseEvent)
		Dim ll As TMapLatLng=MapCenterToLatLng
		Dim s As Double=CalcScale(ll.fLat,fMap.fZoomLevel)
		If SubExists(mCallBack,mEventName & "_scaleClicked") Then
			CallSub2(mCallBack,mEventName & "_scaleClicked",s)
		End If
	End Sub
#end if
#end region

#region centerLatLng
'raise event latlngClicked
#if B4A  or B4i
	Private Sub fViewCenterLatLng_Click
		If SubExists(mCallBack,mEventName & "_CenterlatlngClicked") Then
			CallSub2(mCallBack,mEventName & "_CenterlatlngClicked",fMap.fCenterLatLng)
		End If
	End Sub
#else if B4J
	Private Sub fViewCenterLatLng_MouseClicked (EventData As MouseEvent)
		If SubExists(mCallBack,mEventName & "_CenterlatlngClicked") Then
			CallSub2(mCallBack,mEventName & "_CenterlatlngClicked",fMap.fCenterLatLng)
		End If
	End Sub
#end if
#end region

#region menu
'raise event menuClicked
Private Sub fViewMenu_Click
	If SubExists(mCallBack,mEventName & "_menuClicked") Then
		CallSub(mCallBack,mEventName & "_menuClicked")
	End If
End Sub
#end region

#region compass
'touch compass
Private Sub fViewCompassTouch_Touch (Action As Int, X As Float, Y As Float)
	If Action = fViewCompass.TOUCH_ACTION_MOVE_NOTOUCH Then
		Return
	End If
	#if b4i
		setCompassDirection(Bit.FMod((Round(ATan2D(y-fPanelCompass.Height/2,x-fPanelCompass.Width/2))+90+360), 360))
	#else
		setCompassDirection((Round(ATan2D(y-fViewCompass.Height/2,x-fViewCompass.Width/2))+90+360) Mod 360)
	#End If
End Sub

'click on campass label
#if B4A or B4i
	Private Sub fViewCompassBearing_Click
		If SubExists(mCallBack,mEventName & "_compassClicked") Then
			CallSub2(mCallBack,mEventName & "_compassClicked",fMap.fCompassDirection)
		End If
	End Sub
#Else if B4J
	Private Sub fViewCompassBearing_MouseClicked (EventData As MouseEvent)
		If SubExists(mCallBack,mEventName & "_compassClicked") Then
			CallSub2(mCallBack,mEventName & "_compassClicked",fMap.fCompassDirection)
		End If
	End Sub
#end if

Private Sub fViewCompass_Touch (Action As Int, X As Float, Y As Float) As Boolean
	Return True
End Sub
#end region

#region map touching
'touch on map
Private Sub fViewTouch_Touch (Action As Int, X As Float, Y As Float) As Boolean
	
	'Log(X & ", " & Y)
	
	Select Case Action
		Case 0 'Touch Down
			fLastTouch.fX=X
			fLastTouch.fY=Y
			fStartTouch.fX=X
			fStartTouch.fY=y
			'UDG 26.04.2021
			If mUseTouch And (ClickCount = -1) Then
				ClickCount = 0
				ClickDown = DateTime.Now
				ClickTimer.Enabled = True
			End If
		Case 1 'Touch Up
			'UDG: found difficult on phone to have down/up with same coords
			Dim dist As Double = Sqrt(Power((X-fStartTouch.fX),2) + Power((Y-fStartTouch.fy),2))
			If dist <= 10 Then
			'If X=fStartTouch.fX And Y=fStartTouch.fY Then
				Dim pt As TMapPoint=MapUtilities.initPoint(X,Y)
				Dim ll As TMapLatLng=PointToLatLng(pt)
				#if b4A
					If fMap.fShowGPS Then
						If TouchGPS(X,Y) Then
							Dim g As TMapGPS=MapUtilities.initGPS(ll,fMap.fGPS.fBearing)
							If SubExists(mCallBack,mEventName & "_GPSClicked") Then
								CallSub2(mCallBack,mEventName & "_GPSClicked",g)
								Return True
							End If
							'
						End If
					End If
				#end if
				'UDG 26.04.2021
				If Not(mUseTouch) Then '>>>>> mUseTouch is set in the designer and is False!
					If fMap.fshowShapes Then
						Dim m As Map = TouchInShape(X,Y)
						If m.Size > 0 Then
							If SubExists(mCallBack,mEventName & "_shapesClicked") Then
								CallSub3(mCallBack,mEventName & "_shapesClicked",ll, m)
								Return True
							End If
						End If
					End If
					CallSub2(mCallBack,mEventName & "_mapClicked",ll)
				Else
					ClickUp = DateTime.now
					If (ClickUp - ClickDown) <= Sensitivity Then
						ClickCount = ClickCount+1
						ClickedLL = ll
						'accounts for a doubleclick
						If (ClickCount = 2) Then
							ClickTimer.Enabled = False
							ClickEval
						End If
					Else
						ClickCount = -1
						'do nothing. it's an up following a down but further than alloted Sensitivity time
					End If
				End If
				Return True
			End If
		Case 2 'Touch move
			If Not(fIsMoving) Then
				fIsMoving=True
				MoveTiles(0, X-fLastTouch.fx, Y-fLastTouch.fy)
				fMap.fCenterLatLng=MapCenterToLatLng
				Update_CenterLatLng
				Update_Scale
				Update_shapes
				#if B4A
					Update_GPS
				#end if
				fLastTouch.fX=X
				fLastTouch.fY=y
				fIsMoving=False
			End If
	End Select
	
	Return False
	
End Sub

'Called on second click (tap) or after Sensitivity time is elapsed
Private Sub ClickEval
	Select ClickCount
		Case 0
			'down w/o up in the alloted Sensitivity time
			'do nothing so down will be  "cancelled"
		Case 1
			'if up occurs later than 60% of alloted Senistivity time, we have a longclick
			If Abs(ClickUp-ClickDown) >= Sensitivity*0.60 Then
				'Log("longclick") 
				If SubExists(mCallBack,mEventName & "_mapLongClicked") Then
					CallSub2(mCallBack,mEventName & "_mapLongClicked",ClickedLL)
				End If
			Else
				'Log("click")
				If SubExists(mCallBack,mEventName & "_mapClicked") Then
					CallSub2(mCallBack,mEventName & "_mapClicked",ClickedLL)
				End If
			End If
		Case 2
			'Log("doubleclick")
			If SubExists(mCallBack,mEventName & "_mapDoubleClicked") Then
				CallSub2(mCallBack,mEventName & "_mapDoubleClicked",ClickedLL)
			End If
	End Select
	ClickCount = -1
End Sub

'repeatedly called since first press down (tap) until Sensitivity elapsed time is over
private Sub ctm_tick
	'stop timer and evaluate kind of click, if any valid 
	If (DateTime.Now - ClickDown) >= Sensitivity Then
		ClickTimer.Enabled = False
		ClickEval
	End If
End Sub
#end region

#region GPS
#if B4a
Public Sub GPS_LocationChanged(alocation As Location)
	fMap.fGPS.fLatLng = MapUtilities.initLatLng(alocation.Latitude,alocation.Longitude)
	fMap.fGPS.fBearing = alocation.Bearing
	Update_GPS
End Sub
#end if

Public Sub Update_GPS
	#if b4a
	Dim pt As TMapPoint=LatLngToPoint(fMap.fGPS.fLatLng)
	If fMap.fShowGPS Then
		fViewGPSImage.SetLayoutAnimated(0,pt.fX-fViewGPSImage.Width/2,pt.fy-fViewGPSImage.Height/2,fViewGPSImage.Width,fViewGPSImage.Height)
		fViewGPSImage.Rotation = fMap.fGPS.fBearing
	End If
	If fMap.fFollowGPS Then
		fMap.fCenterLatLng=fMap.fgps.fLatLng
		If fMap.fShowCompass Then
			fMap.fCompassDirection=360-fMap.fGPS.fBearing
		End If
		CreateTiles(fMap.fCenterLatLng,fMap.fZoomLevel)
		Update_Scale
		Update_CompassDirection
		Update_CenterLatLng
		Update_shapes
	End If
	#Else
		fViewGPSImage.Visible=False
	#end if
End Sub

Public Sub TouchGPS(aX As Double,aY As Double) As Boolean
	#if b4A
		'Log("touchGPS")
		Dim pt As TMapPoint=MapUtilities.initPoint(aX,aY)
		Dim r As B4XRect
		r.Initialize(fViewGPSImage.Left,fViewGPSImage.Top,fViewGPSImage.Left+fViewGPSImage.Width,fViewGPSImage.Top+fViewGPSImage.Height)
		Return MapUtilities.PointInRect(pt,r)
	#else
		Return False
	#end if
End Sub
#end region

#region Shapes
private Sub Update_shapes
	
	fShapeCanvas.ClearRect(fShapeCanvas.TargetRect)
	For Each oItem As Object In fMap.fShapes.Values
		CallSub(oItem, "draw")
	Next
	fShapeCanvas.Invalidate
	
End Sub

Private Sub TouchInShape(aX As Double, aY As Double) As Map
	
	Dim m As Map
	Dim p As TMapPoint = MapUtilities.initPoint(aX, aY)
	
	m.Initialize
	
	'Log(fMap.bMultiShapeClick)
	
	'added RBS 02/05/2022
	If fMap.bMultiShapeClick = False Then
		Dim m2 As B4XOrderedMap
		Dim m3 As Map
		Dim iLayer As Int
		m2.Initialize
		m3.Initialize
	End If

	For Each oKey As Object In fMap.fShapes.Keys
		Dim oItem As Object = fMap.fShapes.Get(oKey)
		'will be b4a.sqlitelight1.clsmapshapecircle and ID of patient if clicking a patient marker
		'-----------------------------------------------------------------------------------------
		If CallSub2(oItem, "PointInShape", p) Then
			m.Put(oKey, oItem)
			If fMap.bMultiShapeClick = False Then
				iLayer = CallSub(oItem, "getLayer")
				If iLayer > 0 Then 'so we have the option here to ignore shape clicks
					m2.Put(iLayer & "," & oKey, oKey)
				End If
			End If
		End If
	Next
	
	If fMap.bMultiShapeClick Then
		Return m
	Else
		m2.Keys.Sort(True)
		For Each oKey In m2.Keys
			m3.Put(m2.Get(oKey), m.Get(m2.Get(oKey)))
			Exit 'as only now interested in the first item
		Next
		Return m3
	End If
	
End Sub

Public Sub AddShapeCircle(oKey As Object, aShape As TMapShapeCircle)
	fMap.fShapes.Put(oKey, MapUtilities.instanceShapeCircle(Me, aShape))
End Sub

Public Sub AddShapeImage(oKey As Object, aShape As TMapShapeImage)
	fMap.fShapes.Put(oKey, MapUtilities.instanceShapeImage(Me,aShape))
End Sub

Public Sub AddShapeLine(oKey As Object, aShape As TMapShapeLine)
	fMap.fShapes.Put(oKey, MapUtilities.instanceShapeLine(Me,aShape))
End Sub

Public Sub AddShapePolygon(oKey As Object, aShape As TMapShapePolygon)
	fMap.fShapes.Put(oKey, MapUtilities.instanceShapePolygon(Me,aShape))
End Sub

Public Sub RemoveShape(oKey As Object)
	fMap.fShapes.Remove(oKey)
End Sub

Public Sub getShapeCanvas As B4XCanvas
	Return fShapeCanvas
End Sub
#end region

#region db
'delete tiles from DB (BoxLatLng, Zomm range) and return how many records have been deleted
Public Sub DeleteTilesFromDB(ABoxLatLng As TMapBoxLatLng,aMinZoomLevel As Int,aMaxZoomLevel As Int) As Long
	Try
		Dim r As Long=0
		Dim X1 As Long
		Dim X2 As Long
		Dim Y1 As Long
		Dim Y2 As Long
		For z=aMinZoomLevel To aMaxZoomLevel
			X1=LngToTileX(ABoxLatLng.fLeftTop.fLng,z).ftile
			X2=LngToTileX(ABoxLatLng.fRightBottom.fLng,z).fTile
			Y1=LatToTileY(ABoxLatLng.fLeftTop.flat,z).fTile
			Y2=LatToTileY(ABoxLatLng.fRightBottom.flat,z).fTile
			r=r+fMapTileManager.DeleteTilesFromDB(X1,X2,Y1,Y2,z)
		Next
	Catch
		Log(LastException.Message)
	End Try
	Return r
End Sub

Public Sub EmptyDB As Long
	Return fMapTileManager.emptyDB
End Sub
#end region

